<script setup>
import { ref, computed } from 'vue'
import { DefaultApi, Configuration } from '../../openapi/generated'
import { marked } from 'marked'

import MemoInput from '../molecules/MemoInput.vue'

const props = defineProps({
  memo: {
    type: Object,
    default(rawProps) {
      return {
        id: 'rawProps.id',
        text: 'rawProps.text',
        tag: 'rawProps.tag',
        meta: 'rawProps.meta'
      }
    }
  },
  apiUrl: {
    type: String,
    default: 'http://localhost:1323'
  }
})
const emit = defineEmits(['update', 'delete'])

const editingMemo = ref({})
const editing = computed(() => Object.keys(editingMemo.value).length)
const deleting = ref(false)


// init api
const conf = new Configuration({
  basePath: props.apiUrl,
})
const api = new DefaultApi(conf)

// init tool
marked.use({
  headerIds: false,
  langPrefix: null,
  mangle: false
})


const updateMemo = (id) => {
  console.log(id)

  const text = editingMemo.value.text
  const tag = editingMemo.value.tag
  api.updateMemo({
    id: id,
    newMemo: {
      text: text,
      tag: tag ? tag : undefined
    }
  }).then(result => {
    console.log(result)
    editingMemo.value = {}

    emit('update', result)
  })
}

const deleteMemo = (id) => {
  console.log(id)

  api.deleteMemo({
    id: id
  }).then(() => {
    deleting.value = false

    emit('delete', id)
  })
}

const formatDateTime = (unix) => {
  const time = new Date(unix)
  return time.toLocaleString('ja-JP', { timeZone: 'Asia/Tokyo' }) + '(Asia/Tokyo)'
}
</script>

<template>
  <div class="card">
    <div class="card-header row">
      <div class="col">
        {{ memo.id }} : 
        <span v-if="memo.tag">
          tag: "{{ memo.tag }}", 
        </span>
        {{ formatDateTime(memo.meta.createdAt) }}
        <span v-if="memo.meta.updatedAt != memo.meta.createdAt">
          , updated at: {{ formatDateTime(memo.meta.updatedAt) }}
        </span>
      </div>

      <div 
        v-if="!editing && !deleting"
        class="col d-flex justify-content-end"
      >
        <button type="button" class="btn btn-primary" @click="editingMemo = {...memo}">update</button>
        <button type="button" class="btn btn-danger" @click="deleting = true">del</button>
      </div>

      <div
        v-if="deleting"
        name="delete-memo"
        class="col d-flex justify-content-end"
      >
        削除しますか？
        <div class="buttons">
          <button type="submit" class="btn btn-danger" @click="deleteMemo(memo.id)">ok</button>
          <button type="button" class="btn btn-secondary" @click="deleting = false">cancel</button>
        </div>
      </div>
    </div>

    <div class="card-body">
      <form
        v-if="!editing"
        name="memo"
        class="flex"
      >
        <div class="w-75" v-html="marked.parse(memo.text)"></div>
      </form>
    
      <form
        v-if="editing"
        name="update-memo"
        @submit.prevent="updateMemo(memo.id)"
      >
        修正後
        <MemoInput :id="'card-' + memo.id" v-model:text="editingMemo.text" v-model:tag="editingMemo.tag"></MemoInput>
        <div class="buttons">
          <button type="submit" class="btn btn-primary">ok</button>
          <button type="button" class="btn btn-secondary" @click="editingMemo = {}">cancel</button>
        </div>
      </form>
    </div>
  </div>
</template>

<style scoped>

</style>

